package be.iminds.ilabt.jfed.espec.model;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * AnsibleSpec: configure an ansible host, and run ansible playbooks
 */
public class AnsibleSpec {
    @Nonnull private final AnsibleHostSpec ansibleHostSpec;
    @Nonnull private final List<AnsibleGalaxySpec> ansibleGalaxySpecs;
    @Nonnull private final List<AnsiblePlaybookSpec> ansiblePlaybookSpecs;

    public AnsibleSpec(@Nonnull AnsibleHostSpec ansibleHostSpec,
                       @Nullable List<AnsibleGalaxySpec> ansibleGalaxySpecs,
                       @Nullable List<AnsiblePlaybookSpec> ansiblePlaybookSpecs) {
        this.ansibleHostSpec = ansibleHostSpec;
        this.ansibleGalaxySpecs = ansibleGalaxySpecs == null ? Collections.emptyList() :
                Collections.unmodifiableList(new ArrayList(ansibleGalaxySpecs));
        this.ansiblePlaybookSpecs = ansiblePlaybookSpecs == null ? Collections.emptyList() :
                Collections.unmodifiableList(new ArrayList(ansiblePlaybookSpecs));
    }

    @Nonnull
    public AnsibleHostSpec getAnsibleHostSpec() {
        return ansibleHostSpec;
    }

    @Nonnull
    public List<AnsibleGalaxySpec> getAnsibleGalaxySpecs() {
        return ansibleGalaxySpecs;
    }

    @Nonnull
    public List<AnsiblePlaybookSpec> getAnsiblePlaybookSpecs() {
        return ansiblePlaybookSpecs;
    }
}
